---
title: AVL tree insertion
nav_order: 8
---

Line cases
: ![Line cases](https://docs.google.com/drawings/d/e/2PACX-1vT8Ve-1PD-IIZ6Ilk4qJ3J0Vrdw356ap7Lxixw0LTazanG0rOn3lUG1uecE34b5oAEQx5HsOkgSjM_G/pub?w=960&h=540)

Kink cases
: ![Kink cases](https://docs.google.com/drawings/d/e/2PACX-1vTRhA6QS-rYdNQiBrhL2ajWv9x1OpsB2DcBuc6AvzrpN7GTqJdEDvJKO-Am5qAqlpqX7qYStpAYtFhV/pub?w=960&h=540)

{% capture question %}
Which tree represents the result of inserting the value 0?

![Simple BST](https://docs.google.com/drawings/d/e/2PACX-1vSjdjs56ZrExpKRT2nq1OW-N6Gp5ZXJ75qMBfg7gO1Hn3X4JU9nJjWGYC_WHCtt5frDxloYaZUuaBdI/pub?w=768&h=432)

- [ ] ![Tree 4](https://docs.google.com/drawings/d/e/2PACX-1vShd7DRwQhhSIRoRZtWSPr6cnHcJBHCUJ3Dr8Kx0xiDkM4F9STBqIhJL7fNBj_wd7prYIZmMND4ske-/pub?w=768&h=432)
- [ ] ![Tree 5](https://docs.google.com/drawings/d/e/2PACX-1vRrA3eYFWVEzpEb7Q8gOsIblSqYTLpBh5n0KxgxPWkQoEMBjAdiJgdapudg5__h2zZq7bg22ntXLmPN/pub?w=768&h=432)
- [ ] ![Tree 6](https://docs.google.com/drawings/d/e/2PACX-1vQU7Dzd2IKTsLsnDTnjMiTNMvHw2lDCFhBZX8LnKMab_p5pjD6f1ko3H7z552FZMB6PJKqA39_4C6K0/pub?w=768&h=432)
- [ ] ![Tree 7](https://docs.google.com/drawings/d/e/2PACX-1vTtWiJc8qjQxs73ogWks43pOcPo-Z5_XxzS1ujFAa0LVIvAQgQs6R_ho_H80i1ggp-sPcKkGIZAyg_h/pub?w=768&h=432)
{% endcapture %}
{% capture explanation %}
Option A represents the result of performing just the BST insertion step. The subtree rooted at the node with value -2 violates the AVL tree invariant. Since the insertion path is a line, `rotateLeft(-2)`.
{% endcapture %}
{% include question.html question=question explanation=explanation number=1 %}

{% capture question %}
Suppose we followed the BST insertion procedure to add the value 4 to this AVL tree. Which line/kink violates the AVL tree invariant, where the first node in the line/kink represents the node where the balance factor differs by more than 1?

![Complex BST](https://docs.google.com/drawings/d/e/2PACX-1vQ0Pg_l7P0XF4hsWdP6RjJDzgonChz67xRadEJTw8bAg-xx9s14Csou9P7ugATL_mpv9iSx76GNG0fP/pub?w=768&h=432)

- [ ] **8--2--1**
- [ ] **8--2--6**
- [ ] **2--1--4**
- [ ] **2--6--3**
- [ ] **2--6--7**
- [ ] **6--3--4**
- [ ] **6--7--4**
- [ ] None of the above.
{% endcapture %}
{% capture explanation %}
The BST insertion procedure adds the value 4 as the right child of 3, which eliminates the options that imply 4 would be inserted elsewhere. Compute the balance factors of each node on the insertion path.
{% endcapture %}
{% include question.html question=question explanation=explanation number=2 %}

{% capture question %}
Which tree rotation case is needed to fix the AVL tree invariant when inserting the value 4 into the above tree?

- [ ] Left rotation (line case)
- [ ] Right rotation (line case)
- [ ] Right/left rotation (kink case)
- [ ] Left/right rotation (kink case)
{% endcapture %}
{% include question.html question=question number=3 %}

{% capture question %}
Give **2 sets of answers** to the following questions: What integer, if inserted into the tree, would initially break the AVL invariant? Which rotations would need to be applied afterwards?

![Small BST](https://docs.google.com/drawings/d/e/2PACX-1vTzJ9jKORCvPZ3M7PiFhgvfNqZ-q5vXAcEYEG-DHAJ8eTI1UYnN1j9BWeTMSX6Dx5Im0Plm-tizgOFP/pub?w=768&h=432)
{% endcapture %}
{% include question.html question=question number=4 %}
