---
title: AVL tree invariants
nav_order: 2
---

An AVL tree is a binary search tree that respects the AVL tree invariant: For every node, the height of its left and right subtrees may only differ by at most 1 (balance factor is either -1, 0, or 1).

{% capture question %}
Which of the following are valid AVL trees?

- [ ] ![Tree 1](https://docs.google.com/drawings/d/e/2PACX-1vSC3ngAgXLC0wO776FcU4PZXyrzJPpSbxPX-6HwfltqQ7k0NOhsSb068fbczXGwUp5Rr9ri9Sb2qMa-/pub?w=384&h=216)
- [ ] ![Tree 2](https://docs.google.com/drawings/d/e/2PACX-1vTckRyo-jvqmInO9mYeeVLxcAyR8stQqHI8oTDp3Hs9lOMCmHN9UH7woaXu8dElXYIgiTOzdCjadQ1I/pub?w=384&h=216)
- [ ] ![Tree 3](https://docs.google.com/drawings/d/e/2PACX-1vSJ5CySZbAfdiSqB_kOeUX1pinGgeCLjmtV2AlshaGRWKjmYhn9ECwxK3DYh7pWPekCrI2QVbjbipoN/pub?w=384&h=216)
{% endcapture %}
{% capture explanation %}
- Option A violates the BST invariant between the values 4 and 5.
- Option B violates the AVL tree balance factor at the node with value 3.
- Option C meets both the BST invariant and the AVL tree invariant.
{% endcapture %}
{% include question.html question=question explanation=explanation number=1 %}
