---
title: Balance factor
nav_order: 0
---

In our study of balanced search trees, we considered the hypothesis that unbalanced growth leads to worst-case height trees. With 2-3 trees, we addressed this hypothesis by never creating new leaf nodes and instead growing the tree by splitting nodes in a way that ensured relatively-balanced growth. With left-leaning red-black trees, we took the concept of a 2-3 tree and defined corresponding rotations and color flips to represent any 2-3 tree as a binary search tree.

In this lesson, we'll examine AVL trees, which are another type of balanced search tree data structure that can be used to implement sets and maps. While LLRB trees derived their properties from 2-3 trees, AVL trees directly address unbalanced growth by ensuring that every node is **balanced**.

Balance factor
: For a given node, compute the height of right subtree minus the height of the left subtree.
