---
title: Binary heap operations
nav_order: 4
---

By definition, the lowest-priority element in a min-heap is always stored in the overall root. To implement the `min` method, just return the root item. Implementing `removeMin` is a bit trickier.

<div style="--aspect-ratio: 720 / 405; --add-height: 29px"><iframe src="https://docs.google.com/presentation/d/e/2PACX-1vQRrkzMd1VhDXX-EkbR1DE4um4zvpULoC0KFv0aXat7_C3_M5xxB4ENyTQSkWSVniaGWqKK08H0r4Ws/embed?start=false&loop=false&delayms=3000" frameborder="0" width="720" height="434" allowfullscreen="true" mozallowfullscreen="true" webkitallowfullscreen="true"></iframe></div>

`removeMin`
: 1. Swap the root with the last leaf.
  2. Remove the last leaf.
  3. Sink the new root to its proper place, promoting the lesser child.

The **sink** operation swaps the current node with one of its children, "sinking" the current node down the heap.

Sink
: Swap a node down the tree until it is lesser than both of its children. Promote the lesser child. Break ties arbitrarily.

Likewise, we can define a **swim** operation to swap the current node with its parent.

Swim
: Swap a node up the tree until its parent is lesser than itself.

We can define `add` and maintain the binary heap invariants using the swim operation.

`add`
: 1. Add the item in the next open leaf position (from the left) on the bottom level.
  2. Swim to restore heap invariants.
