---
title: Heap constraints
nav_order: 9
---

Suppose this binary min-heap stores the lowest-priority element in the overall root node and the second-lowest element in its left child. Assume all elements and priority values are distinct.

![Heap Two Blank](https://docs.google.com/drawings/d/e/2PACX-1vQjI2WUMINKaneJgahNMlsWUtv48eDfhbqe6MqHX10WBNdCLjBKy9PovPVeWpjZ0W5E3P7c4I4F1321/pub?w=768&h=432)

{% capture question %}
Select all nodes where the **third-lowest-priority element** could be found.

- [ ] **A**
- [ ] **B**
- [ ] **C**
- [ ] **D**
- [ ] **E**
- [ ] **F**
- [ ] **G**
{% endcapture %}
{% capture explanation %}
Since all priority values are unique, the third-lowest priority element can only be at most 3 away beneath the root. D and E won't work since we've already established that the second-lowest priority element is the overall root's left child.
{% endcapture %}
{% include question.html question=question number=1 %}

{% capture question %}
Select all nodes where the **highest-priority element** could be found.

- [ ] **A**
- [ ] **B**
- [ ] **C**
- [ ] **D**
- [ ] **E**
- [ ] **F**
- [ ] **G**
{% endcapture %}
{% capture explanation %}
We can apply the same logic for the highest-priority element except thinking from the leaves. Only the leaf nodes can contain the highest-priority element.
{% endcapture %}
{% include question.html question=question number=2 %}
