---
title: Heap indexing
nav_order: 10
---

Consider the following binary min-heap of integers with `__` denoting blank spaces in the array. Coincidentally, the value of the integer lines up with its index in the array representation of the heap. Note that this implementation is using the zero-indexed array representation.

```
[0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, __, __, __, __]
```

{% capture question %}
Give the index representing the minimum value.
{% endcapture %}
{% include question.html question=question number=1 %}

{% capture question %}
Give the index representing the last leaf node on the bottommost level.
{% endcapture %}
{% include question.html question=question number=2 %}

{% capture question %}
Give the index representing the left child of the value `3`.
{% endcapture %}
{% include question.html question=question number=3 %}

{% capture question %}
Give the index representing the right child of the value `3`.
{% endcapture %}
{% include question.html question=question number=4 %}

{% capture question %}
Give the index representing the parent of the value `10`.
{% endcapture %}
{% include question.html question=question number=5 %}
