---
title: LLRB tree height
nav_order: 8
---

Given a 2-3 tree, the height of the corresponding left-leaning red-black tree depends on the number of 3-nodes.

{% capture question %}
Give the exact height of the corresponding LLRB tree.

![Big 2-3 Tree](https://docs.google.com/drawings/d/e/2PACX-1vQLWW0wfjq1fq2QlZ1yfY5PuSf0vMR5vaWwUG4RvOSNLzRTsEz9Znqk2pI4dOhedKBak30MQiBHf2__/pub?w=960&h=540)
{% endcapture %}
{% capture explanation %}
The path **M--Q--TV--RS** is the longest path in the corresponding LLRB tree since it contains two 3-nodes that will each contribute one additional level to the height of the tree.
{% endcapture %}
{% include question.html question=question explanation=explanation number=1 %}

{% capture question %}
Given a 2-3 tree of height *H*, give the exact worst-case height of the corresponding LLRB tree as a (simple) function of *H*.
{% endcapture %}
{% capture explanation %}
A 2-3 tree of height *H* has *H* + 1 nodes on any root-to-leaf path, each of which can be a 3-node that contributes one additional edge to the overall height of the tree.
{% endcapture %}
{% include question.html question=question explanation=explanation number=2 %}
