---
title: method1
nav_order: 9
---

Consider the following method.

```java
static int method1(int N) {
  if (N <= 1) {
      return 1;
  } else {
      int a = method1(N - 1);
      int b = method1(N - 1);
      int c = method1(N - 1);
      return a + b + c;
  }
}
```

{% capture question %}
Give a recurrence relation that describes the runtime of `method1`.
{% endcapture %}
{% include question.html question=question number=1 %}

{% capture question %}
True/False: If we solved the recurrence diagram, we can use **assumption 1** in a work-per-level analysis.

Assumption 1
: Each node on level *i* performs the same amount of work, so we can multiply the work per node by the number of nodes on that level.
{% endcapture %}
{% capture explanation %}
Each node contributes the same amount of (non-recursive) work, so we can multiply by the number of nodes in the level.
{% endcapture %}
{% include question.html question=question explanation=explanation number=2 %}

{% capture question %}
True/False: If we solved the recurrence diagram, we can use **assumption 2** in a work-per-level analysis.

Assumption 2
: Each level performs the same amount of work, so we can multiply the work per level by the number of levels to get the total runtime of the entire recurrence.
{% endcapture %}
{% capture explanation %}
Each level contributes a different amount of work, so we can't multiply the work-per-level by the number of levels.
{% endcapture %}
{% include question.html question=question explanation=explanation number=3 %}
